%define         sope_soname            4_9
%define         sope_version           4.9
%define         gs_makefiles           %_libdir/GNUstep/Makefiles
%define         oname SOPE

Name:           sope
Summary:        SKYRiX Object Publishing Environment
Version:        5.10.0
Release:        %mkrel 2
License:        GPLv2+
Group:          System/Libraries
Url:            https://www.sogo.nu/
Source:         https://github.com/Alinto/sope/archive/refs/tags/%{oname}-%{version}.tar.gz
Patch0:         SOPE-2.2.14-fix-link.patch
Patch1:         SOPE-2.2.14-aarch64.patch
BuildRequires:  gcc-objc
BuildRequires:  pkgconfig(gnustep-base)
BuildRequires:  mysql-devel
BuildRequires:  pkgconfig(libxml-2.0)
BuildRequires:  openldap-devel
BuildRequires:  pkgconfig(openssl)
BuildRequires:  pkgconfig
BuildRequires:  postgresql-devel
BuildRequires:  pkgconfig(sqlite3)
BuildRequires:  fdupes
BuildRequires:  gnustep-base

Obsoletes:      libSBJson2 <= 2.3.1


%description
SOPE is a framework for developing web applications and services. The
name "SOPE" (SKYRiX Object Publishing Environment) is inspired by ZOPE.

%package devel
Summary:        Development files for the SOPE libraries
Group:          Development/C#
Requires:       libGDLAccess%{sope_soname} = %{version}
Requires:       libNGLdap%{sope_soname} = %{version}
Requires:       libNGMime%{sope_soname} = %{version}
Requires:       %{name}-appserver = %{version}
Requires:       %{name}-core = %{version}
Requires:       %{name}-xml = %{version}
Requires:       gnustep-make
Requires:       mysql-devel
Requires:       libxml2-devel
Requires:       openldap-devel
Requires:       postgresql-devel
Requires:       pkgconfig
Requires:       sqlite3-devel

%description devel
This package contains the development files of the SOPE libraries.


%package appserver
Summary:        SOPE application server libraries
Group:          System/Libraries
Requires:       %{name}-core
Requires:       %{name}-xml

%description appserver
The SOPE application server libraries provide:

  * template rendering engine, lots of dynamic elements
  * HTTP client/server
  * XML-RPC client
  * WebDAV server framework
  * session management
  * scripting extensions for Foundation, JavaScript bridge
  * DOM tree rendering library

%package core
Summary:        Core libraries of the SOPE application server
Group:          System/Libraries
Requires:       %{name}-xml

%description core
The SOPE core libraries contain:

  * various Foundation extensions
  * a java.io like stream and socket library

%package xml
Summary:        SOPE libraries for XML processing
Group:          System/Libraries

%description xml
The SOPE libraries for XML processing contain:

  * a SAX2 Implementation for Objective-C
  * an attempt to implement DOM on top of SaxObjC
  * an XML-RPC implementation (without a transport layer)

%package -n libGDLAccess%{sope_soname}
Summary:        GNUstep database libraries for SOPE
Group:          System/Libraries
Requires:       %{name}-core
Requires:       %{name}-xml

%description -n libGDLAccess%{sope_soname}
This package contains a fork of the GNUstep database libraries used
by the SOPE application server.

%package -n libNGLdap%{sope_soname}
Summary:        SOPE libraries for LDAP access
Group:          System/Libraries
Requires:       %{name}-core
Requires:       %{name}-xml
Requires:       openldap

%description -n libNGLdap%{sope_soname}
The SOPE libraries for LDAP access contain an Objective-C wrapper for
LDAP directory services.

%package -n libNGMime%{sope_soname}
Summary:        SOPE libraries for MIME processing
Group:          System/Libraries
Requires:       %{name}-core
Requires:       %{name}-xml

%description -n libNGMime%{sope_soname}
The SOPE libraries for MIME processing contain:

  * classes for processing MIME entities
  * a full IMAP4 implementation
  * prototypical POP3 and SMTP processor

%package gdl1-mysql
Summary:        MySQL connector for SOPE's fork of the GNUstep database environment
Group:          System/Libraries

%description gdl1-mysql
This package contains the MySQL connector for SOPE's fork of the
GNUstep database libraries.

%package gdl1-postgresql
Summary:        PostgreSQL connector for SOPE's fork of the GNUstep database environment
Group:          System/Libraries
%if %{?_postgresql_server_is_within_postgresql:1}%{!?_postgresql_server_is_within_postgresql:0}
Requires:       postgresql
%else
Requires:       postgresql-server
%endif

%description gdl1-postgresql
This package contains the PostgreSQL connector for SOPE's fork of the
GNUstep database libraries.

SOPE is a framework for developing web applications and services. The
name "SOPE" (SKYRiX Object Publishing Environment) is inspired by ZOPE.

%prep
%setup -q -n sope-%{oname}-%{version}
%autopatch -p1

# fix build on aarch64
for d in $(find . -name "config.sub");do
  cp -af %{_rpmconfigdir}/%{_real_vendor}/config.{guess,sub} $(dirname $d)
done

%build
. %_libdir/GNUstep/Makefiles/GNUstep.sh

./configure --prefix=%{_prefix} \
  --disable-debug \
  --disable-strip \
  --gsmake=%_libdir/GNUstep/Makefiles

%make_build
%make_build -C sope-gdl1/MySQL

%install
install -d %{buildroot}%{_prefix}/lib

%make_install \
  GNUSTEP_INSTALLATION_DOMAIN=SYSTEM

%make_install -C sope-gdl1/MySQL \
  GNUSTEP_INSTALLATION_DOMAIN=SYSTEM

rm -f %{buildroot}%{_bindir}/rss2plist1
rm -f %{buildroot}%{_bindir}/rss2plist2
rm -f %{buildroot}%{_bindir}/rssparse
rm -f %{buildroot}%{_bindir}/testqp
rm -fr %{buildroot}%{_prefix}/man/

%fdupes %{buildroot}%{_libdir}/sope-%{sope_version}

%files xml
%{_libdir}/libDOM*.so.%{sope_version}{,.*}
%{_libdir}/libSaxObjC*.so.%{sope_version}{,.*}
%{_libdir}/libXmlRpc*.so.%{sope_version}{,.*}
%dir %{_libdir}/sope-%{sope_version}/saxdrivers/
%dir %{_datadir}/sope-%{sope_version}/
%{_libdir}/sope-%{sope_version}/saxdrivers/libxmlSAXDriver.sax
%{_libdir}/sope-%{sope_version}/saxdrivers/STXSaxDriver.sax

%files core
%{_libdir}/libEOControl*.so.%{sope_version}{,.*}
%{_libdir}/libNGExtensions*.so.%{sope_version}{,.*}
%{_libdir}/libNGStreams*.so.%{sope_version}{,.*}
%dir %{_libdir}/sope-%{sope_version}/
%{_libdir}/libSBJson.so.*

%files appserver
%{_libdir}/libNGObjWeb*.so.%{sope_version}{,.*}
%{_libdir}/libWEExtensions*.so.%{sope_version}{,.*}
%{_libdir}/libWOExtensions*.so.%{sope_version}{,.*}
%dir %{_datadir}/sope-%{sope_version}/ngobjweb/
%{_datadir}/sope-%{sope_version}/ngobjweb/DAVPropMap.plist
%{_datadir}/sope-%{sope_version}/ngobjweb/Defaults.plist
%{_datadir}/sope-%{sope_version}/ngobjweb/Languages.plist
%dir %{_libdir}/sope-%{sope_version}/products/
%{_libdir}/sope-%{sope_version}/products/SoCore.sxp
%dir %{_libdir}/sope-%{sope_version}/wox-builders/
%{_libdir}/sope-%{sope_version}/wox-builders/WEExtensions.wox
%{_libdir}/sope-%{sope_version}/wox-builders/WOExtensions.wox

%files -n libGDLAccess%{sope_soname}
%{_bindir}/connect-EOAdaptor
%{_bindir}/load-EOAdaptor
%{_libdir}/libGDLAccess*.so.%{sope_version}{,.*}
%dir %{_libdir}/sope-%{sope_version}/dbadaptors/

%files -n libNGLdap%{sope_soname}
%{_libdir}/libNGLdap*.so.%{sope_version}{,.*}

%files -n libNGMime%{sope_soname}
%{_libdir}/libNGMime*.so.%{sope_version}{,.*}

%files gdl1-mysql
%{_libdir}/sope-%{sope_version}/dbadaptors/MySQL.gdladaptor

%files gdl1-postgresql
%{_libdir}/sope-%{sope_version}/dbadaptors/PostgreSQL.gdladaptor

%files devel
# ***** appserver *****
%{_bindir}/wod
%{_includedir}/NGHttp
%{_includedir}/NGObjWeb
%{_includedir}/WEExtensions
%{_includedir}/WOExtensions
%{_libdir}/libNGObjWeb*.so
%{_libdir}/libWEExtensions*.so
%{_libdir}/libWOExtensions*.so
%{gs_makefiles}/Additional/ngobjweb.make
%{gs_makefiles}/woapp.make
%{gs_makefiles}/wobundle.make
# ***** core *****
%{_includedir}/EOControl
%{_includedir}/NGExtensions
%{_includedir}/NGStreams
%{_libdir}/libEOControl*.so
%{_libdir}/libNGExtensions*.so
%{_libdir}/libNGStreams*.so
# ***** xml *****
%{_includedir}/DOM
%{_includedir}/SaxObjC
%{_includedir}/XmlRpc
%{_libdir}/libDOM*.so
%{_libdir}/libSaxObjC*.so
%{_libdir}/libXmlRpc*.so
# ***** LibGDLAccess *****
%{_includedir}/GDLAccess
%{_libdir}/libGDLAccess*.so
# ***** LibNGLdaps *****
%{_includedir}/NGLdap
%{_libdir}/libNGLdap*.so
# ***** LibNGMime *****
%{_includedir}/NGImap4
%{_includedir}/NGMail
%{_includedir}/NGMime
%{_libdir}/libNGMime*.so
# ***** LibSNJson *****
%{_includedir}/SBJson
%{_libdir}/libSBJson.so


%changelog
* Mon Aug 12 2024 daviddavid <daviddavid> 5.10.0-2.mga10
+ Revision: 2086310
- rebuild for new gnustep-base 1.30.0

* Wed Jun 05 2024 papoteur <papoteur> 5.10.0-1.mga10
+ Revision: 2070078
- new version 5.10.0

* Tue Dec 06 2022 daviddavid <daviddavid> 5.6.0-2.mga9
+ Revision: 1918619
- rebuild for new gnustep-base 1.28.0

* Tue May 24 2022 papoteur <papoteur> 5.6.0-1.mga9
+ Revision: 1859975
- remove libSBJson2 package and put its lib file in sope-core
- new 5.6.0 (mga#29255)

* Wed Apr 06 2022 umeabot <umeabot> 5.4.0-4.mga9
+ Revision: 1845858
- Mageia 9 Mass Rebuild

* Fri Dec 17 2021 neoclust <neoclust> 5.4.0-3.mga9
+ Revision: 1762420
- Fix version
- New version 5.4.0

* Sat Oct 02 2021 wally <wally> 5.0.1-2.mga9
+ Revision: 1747915
- rebuild for openssl 3.0.0

* Sun Dec 13 2020 neoclust <neoclust> 5.0.1-1.mga8
+ Revision: 1656549
- New version 5.0.1

* Mon Nov 02 2020 wally <wally> 4.0.0-8.mga8
+ Revision: 1641752
- update config.{guess,sub} fix for rpm 4.16.0 beta1 and rpm-mageia-setup

* Sun Feb 16 2020 umeabot <umeabot> 4.0.0-7.mga8
+ Revision: 1534804
- Mageia 8 Mass Rebuild

* Sun Oct 06 2019 daviddavid <daviddavid> 4.0.0-6.mga8
+ Revision: 1449930
- rebuild for gnustep-base 1.26.0

* Sun Sep 23 2018 umeabot <umeabot> 4.0.0-5.mga7
+ Revision: 1301106
- Mageia 7 Mass Rebuild

* Sun Jul 29 2018 wally <wally> 4.0.0-4.mga7
+ Revision: 1245768
- add fixes for aarch64

* Wed Mar 28 2018 kekepower <kekepower> 4.0.0-3.mga7
+ Revision: 1213212
- Update to version 4.0.0

* Sat Dec 23 2017 wally <wally> 3.2.8-3.mga7
+ Revision: 1184224
- rebuild for new mariadb

* Wed Sep 06 2017 cjw <cjw> 3.2.8-2.mga7
+ Revision: 1151638
- rebuild for openssl 1.1

* Wed Apr 26 2017 neoclust <neoclust> 3.2.8-1.mga6
+ Revision: 1097467
- New version - Fixes (CVE-2016-618[89], CVE-2016-619[01], CVE-2014-9905) (mga#18697)

* Thu Mar 03 2016 umeabot <umeabot> 2.3.1-5.mga6
+ Revision: 984122
- Rebuild for openssl

* Wed Feb 17 2016 umeabot <umeabot> 2.3.1-4.mga6
+ Revision: 962875
- Mageia 6 Mass Rebuild

* Mon Oct 26 2015 daviddavid <daviddavid> 2.3.1-3.mga6
+ Revision: 895567
- turn off stripping of debug symbols to fix empty debuginfo
- fix License

* Sun Aug 02 2015 neoclust <neoclust> 2.3.1-2.mga6
+ Revision: 860786
- New version 2.3.1

* Thu Jul 09 2015 neoclust <neoclust> 2.3.0-1.mga6
+ Revision: 853037
- New version
- imported package sope


* Mon Feb 02 2015 nlecureuil <nlecureuil> 2.2.15-5.mbs1
+ Revision: 146441
- New version

* Wed Jan 21 2015 nlecureuil <nlecureuil> 2.2.14-4.mbs2
+ Revision: 145969
- Fix build of json lib

* Wed Jan 21 2015 nlecureuil <nlecureuil> 2.2.14-3.mbs2
+ Revision: 145963
- Fix Requires

* Wed Jan 21 2015 nlecureuil <nlecureuil> 2.2.14-2.mbs2
+ Revision: 145959
- Fix Requires

* Wed Jan 21 2015 nlecureuil <nlecureuil> 2.2.14-1.mbs2
+ Revision: 145953
- imported package sope

